javax.security.auth.message.config

## Interface ClientAuthConfig

- All Superinterfaces:
    AuthConfig

      public interface ClientAuthConfig
      extends AuthConfig

  This interface encapsulates the configuration of ClientAuthContext objects for a message layer and application context (for example, the messaging context of a specific application, or set of applications).

  Implementations of this interface are returned by an AuthConfigProvider.

  Callers interact with a ClientAuthConfig to obtain ClientAuthContext objects suitable for processing a given message exchange at the layer and within the application context of the ClientAuthConfig. Each ClientAuthContext object is responsible for instantiating, initializing, and invoking the one or more ClientAuthModules encapsulated in the ClientAuthContext.

  After having acquired a ClientAuthContext, a caller operates on the context to cause it to invoke the encapsulated ClientAuthModules to secure client requests and to validate server responses.

  See Also:
    `AuthConfigProvider`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ClientAuthContext` | `getAuthContext(String authContextID, Subject clientSubject, Map properties)` Get a ClientAuthContext instance from this ClientAuthConfig.

    - ### Methods inherited from interface javax.security.auth.message.config.AuthConfig

      `getAppContext, getAuthContextID, getMessageLayer, isProtected, refresh`

- - ### Method Detail

    - #### getAuthContext

          ClientAuthContext getAuthContext(String authContextID,
                                         Subject clientSubject,
                                         Map properties)
                                           throws AuthException

      Get a ClientAuthContext instance from this ClientAuthConfig.

      The implementation of this method returns a ClientAuthContext instance that encapsulates the ClientAuthModules used to secure and validate requests/responses associated with the given authContextID.

      Specifically, this method accesses this ClientAuthConfig object with the argument authContextID to determine the ClientAuthModules that are to be encapsulated in the returned ClientAuthContext instance.

      The ClientAuthConfig object establishes the request and response MessagePolicy objects that are passed to the encapsulated modules when they are initialized by the returned ClientAuthContext instance. It is the modules' responsibility to enforce these policies when invoked.

      Parameters:
        `authContextID` - An String identifier used to index the provided config, or null. This value must be identical to the value returned by the `getAuthContextID` method for all `MessageInfo` objects passed to the `secureRequest` method of the returned ClientAuthContext.
        `clientSubject` - A Subject that represents the source of the service request to be secured by the acquired authentication context. The principals and credentials of the Subject may be used to select or acquire the authentication context. If the Subject is not null, additional Principals or credentials (pertaining to the source of the request) may be added to the Subject. A null value may be passed for this parameter.
        `properties` - A Map object that may be used by the caller to augment the properties that will be passed to the encapsulated modules at module initialization. The null value may be passed for this parameter.
      Returns:
        A ClientAuthContext instance that encapsulates the ClientAuthModules used to secure and validate requests/responses associated with the given authContextID, or null (indicating that no modules are configured).
      Throws:
        `AuthException` - If this method fails.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.